﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using RimWorld;
using Verse;

namespace Immortals
{
    public static class BeheadableUtility
    {
        public static bool CanBeBeheaded(Thing thing)
        {
            if (thing is Corpse)
            {
                if ((thing as Corpse).InnerPawn.health.hediffSet.HasHead)
                    return true;
            }
            if (thing is Pawn)
            {
                if ((thing as Pawn).health.hediffSet.HasHead && (thing as Pawn).Downed)
                {
                    return true;
                }
                else
                {
                    Designation designation = thing.Map.designationManager.DesignationOn(thing, DefDatabase<DesignationDef>.GetNamed("IH_Behead"));
                    if (designation != null)
                    {
                        designation.Delete();
                    }
                }
                    
            }
            return false;
        }
    }
}
