﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Verse;
using RimWorld;

namespace Immortals
{
    class GameCondition_Quickening : GameCondition
    {
        public override void ExposeData()
        {
            base.ExposeData();
            Scribe_Values.Look<Pawn>(ref pawn, "recievingPawn");
            Scribe_Values.Look(ref strikesLeft, "strikesLeft");

        }
        public override string Label => "Quickening";

        public override void Init()
        {
            base.Init();
            strikesLeft = Rand.RangeInclusive(10, 20);
            nextTick = Find.TickManager.TicksGame + Rand.RangeInclusive(30, 50);
            
        }

        public override void GameConditionTick()
        {
           
            if (pawn != null)
            {
                if (Find.TickManager.TicksGame > this.nextTick)
                {
                    int xOff = Rand.Range(-5, 5);
                    int zOff = Rand.Range(-5, 5);
                    IntVec3 pos = pawn.Position;
                    pos.x += xOff;
                    pos.z += zOff;
                    pawn.Map.weatherManager.eventHandler.AddEvent(new WeatherEvent_Quickening(pawn.Map, pos, Rand.RangeInclusive(3, 10), false));
                    nextTick = Find.TickManager.TicksGame + Rand.RangeInclusive(20, 40);
                    strikesLeft -= 1;
                    if (strikesLeft <= 0)
                        End();
                }
            }
            
        }

        public override void End()
        {
            base.End();
        }
        public Pawn pawn;
        int strikesLeft;
        int nextTick;
    }
}
